Index: /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/ShapeConstraintView.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/ShapeConstraintView.cs	(revision 17902)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/ShapeConstraintView.cs	(revision 17902)
@@ -0,0 +1,204 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System;
+using System.ComponentModel;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Problems.DataAnalysis.Views {
+  [View("Shape Constraint View")]
+  [Content(typeof(ShapeConstraint), true)]
+  public sealed partial class ShapeConstraintView : ItemView {
+    public new ShapeConstraint Content {
+      get => (ShapeConstraint)base.Content;
+      set => base.Content = value;
+    }
+
+    public ShapeConstraintView() {
+      InitializeComponent();
+      int[] items = { 1, 2, 3 };
+      numberOfDerivationsComboBox.DataSource = items;
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      this.regionView.Content = Content.Regions;
+      UpdateControls();
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.Changed += Content_Changed;
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.Changed -= Content_Changed;
+      base.DeregisterContentEvents();
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      variableInput.Enabled = Content != null && !Locked && !ReadOnly;
+      numberOfDerivationsComboBox.Enabled = Content != null && !Locked && !ReadOnly;
+      lowerboundInput.Enabled = Content != null && !Locked && !ReadOnly;
+      upperboundInput.Enabled = Content != null && !Locked && !ReadOnly;
+      weightTextBox.Enabled = Content != null && !Locked && !ReadOnly;
+    }
+
+
+    #region helpers
+
+    private static double ParseDoubleValue(string input, Control control, ErrorProvider errorProvider) {
+      input = input.ToLower();
+      switch (input) {
+        case "inf.":
+        case "+inf.":
+        case "Infinity":
+          return double.PositiveInfinity;
+        case "-inf.":
+        case "-Infinity":
+          return double.NegativeInfinity;
+        default: {
+            if (double.TryParse(input, out var value)) {
+              return value;
+            }
+
+            errorProvider.SetError(control, "Invalid input: value must be a double.");
+            return double.NaN;
+          }
+      }
+    }
+
+    private void UpdateControls() {
+      if (Content == null) {
+        lowerboundInput.Text = string.Empty;
+        upperboundInput.Text = string.Empty;
+        weightTextBox.Text = string.Empty;
+        return;
+      }
+
+      lowerboundInput.Text = Content.Interval.LowerBound.ToString();
+      upperboundInput.Text = Content.Interval.UpperBound.ToString();
+      weightTextBox.Text = Content.Weight.ToString();
+
+      variableInput.Text = Content.Variable;
+      if (!Content.IsDerivative) {
+        numberOfDerivationsComboBox.Enabled = false;
+        numberOfDerivationsComboBox.SelectedItem = null;
+        numberOfDerivationsComboBox.Text = "0";
+      } else {
+        numberOfDerivationLabel.Visible = true;
+        numberOfDerivationsComboBox.Visible = true;
+        numberOfDerivationsComboBox.Enabled = true;
+        numberOfDerivationsComboBox.SelectedItem = Content.NumberOfDerivations;
+      }
+
+      regionView.Content = Content.Regions;
+    }
+
+    #endregion
+
+    #region control event handlers
+
+    private void lowerboundInput_Validating(object sender, CancelEventArgs e) {
+      var value = ParseDoubleValue(lowerboundInput.Text, lowerboundInput, errorProvider);
+      if (double.IsNaN(value)) {
+        errorProvider.SetError(lowerboundInput, "Invalid input: lower bound must be a double value.");
+        e.Cancel = true;
+        return;
+      }
+
+      if (value > Content.Interval.UpperBound) {
+        errorProvider.SetError(lowerboundInput, "Invalid input: lower bound must be smaller than upper bound.");
+        e.Cancel = true;
+        return;
+      }
+
+      errorProvider.SetError(lowerboundInput, string.Empty);
+      e.Cancel = false;
+    }
+
+    private void lowerboundInput_Validated(object sender, EventArgs e) {
+      var value =
+        ParseDoubleValue(lowerboundInput.Text, lowerboundInput, errorProvider);
+      if (!double.IsNaN(value)) Content.Interval = new Interval(value, Content.Interval.UpperBound);
+    }
+
+    private void upperboundInput_Validating(object sender, CancelEventArgs e) {
+      var value = ParseDoubleValue(upperboundInput.Text, upperboundInput, errorProvider);
+      if (double.IsNaN(value)) {
+        errorProvider.SetError(upperboundInput, "Invalid Input: upper bound must be a double value.");
+        e.Cancel = true;
+        return;
+      }
+
+      if (value < Content.Interval.LowerBound) {
+        errorProvider.SetError(upperboundInput, "Invalid input: upper bound must be bigger than lower bound.");
+        e.Cancel = true;
+        return;
+      }
+
+      errorProvider.SetError(upperboundInput, string.Empty);
+      e.Cancel = false;
+    }
+
+    private void upperboundInput_Validated(object sender, EventArgs e) {
+      var value =
+        ParseDoubleValue(upperboundInput.Text, upperboundInput, errorProvider);
+      if (!double.IsNaN(value)) Content.Interval = new Interval(Content.Interval.LowerBound, value);
+    }
+
+    private void numberderivationInput_SelectedIndexChanged(object sender, EventArgs e) {
+      if (numberOfDerivationsComboBox.SelectedItem == null) {
+        Content.NumberOfDerivations = 0;
+        numberOfDerivationsComboBox.Enabled = false;
+        return;
+      }
+
+      if ((int)numberOfDerivationsComboBox.SelectedItem == 1)
+        Content.NumberOfDerivations = 1;
+      else if ((int)numberOfDerivationsComboBox.SelectedItem == 2)
+        Content.NumberOfDerivations = 2;
+      else if ((int)numberOfDerivationsComboBox.SelectedItem == 3)
+        Content.NumberOfDerivations = 3;
+    }
+
+    private void weightInput_TextChanged(object sender, EventArgs e) {
+      var value = ParseDoubleValue(weightTextBox.Text, weightTextBox, errorProvider);
+      if (!double.IsNaN(value)) Content.Weight = value;
+    }
+
+
+    #endregion
+
+    #region content event handlers
+
+    private void Content_Changed(object sender, EventArgs e) {
+      UpdateControls();
+    }
+
+   #endregion
+  }
+}
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/ShapeConstraintsView.Designer.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/ShapeConstraintsView.Designer.cs	(revision 17902)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/ShapeConstraintsView.Designer.cs	(revision 17902)
@@ -0,0 +1,184 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+using System;
+using System.Drawing;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+
+namespace HeuristicLab.Problems.DataAnalysis.Views {
+  partial class ShapeConstraintsView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+            this.components = new System.ComponentModel.Container();
+            this.splitContainer = new System.Windows.Forms.SplitContainer();
+            this.groupBox = new System.Windows.Forms.GroupBox();
+            this.constraintsInput = new System.Windows.Forms.TextBox();
+            this.parseBtn = new System.Windows.Forms.Button();
+            this.infoLabel = new System.Windows.Forms.Label();
+            this.errorOutput = new System.Windows.Forms.Label();
+            this.shapeConstraintsView = new HeuristicLab.Core.Views.CheckedItemListView<ShapeConstraint>();
+            this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+            ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
+            this.splitContainer.Panel1.SuspendLayout();
+            this.splitContainer.Panel2.SuspendLayout();
+            this.splitContainer.SuspendLayout();
+            this.groupBox.SuspendLayout();
+            this.SuspendLayout();
+            // 
+            // splitContainer1
+            // 
+            this.splitContainer.Dock = System.Windows.Forms.DockStyle.Fill;
+            this.splitContainer.Location = new System.Drawing.Point(0, 0);
+            this.splitContainer.Name = "splitContainer1";
+            // 
+            // splitContainer1.Panel1
+            // 
+            this.splitContainer.Panel1.Controls.Add(this.groupBox);
+            // 
+            // splitContainer1.Panel2
+            // 
+            this.splitContainer.Panel2.Controls.Add(this.shapeConstraintsView);
+            this.splitContainer.Size = new System.Drawing.Size(888, 629);
+            this.splitContainer.SplitterDistance = 296;
+            this.splitContainer.TabIndex = 0;
+            // 
+            // groupBox1
+            // 
+            this.groupBox.Controls.Add(this.constraintsInput);
+            this.groupBox.Controls.Add(this.parseBtn);
+            this.groupBox.Controls.Add(this.infoLabel);
+            this.groupBox.Controls.Add(this.errorOutput);
+            this.groupBox.Dock = System.Windows.Forms.DockStyle.Fill;
+            this.groupBox.Location = new System.Drawing.Point(0, 0);
+            this.groupBox.Name = "groupBox1";
+            this.groupBox.Size = new System.Drawing.Size(296, 629);
+            this.groupBox.TabIndex = 3;
+            this.groupBox.TabStop = false;
+            this.groupBox.Text = "Constraints Input";
+            // 
+            // constraintsInput
+            // 
+            this.constraintsInput.AcceptsTab = true;
+            this.constraintsInput.Dock = System.Windows.Forms.DockStyle.Fill;
+            this.constraintsInput.Location = new System.Drawing.Point(3, 29);
+            this.constraintsInput.Multiline = true;
+            this.constraintsInput.Name = "constraintsInput";
+            this.constraintsInput.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
+            this.constraintsInput.Size = new System.Drawing.Size(290, 561);
+            this.constraintsInput.TabIndex = 2;
+            this.constraintsInput.TextChanged += new System.EventHandler(this.constraintsInput_TextChanged);
+            // 
+            // parseBtn
+            // 
+            this.parseBtn.Dock = System.Windows.Forms.DockStyle.Bottom;
+            this.parseBtn.Location = new System.Drawing.Point(3, 590);
+            this.parseBtn.Name = "parseBtn";
+            this.parseBtn.Size = new System.Drawing.Size(290, 23);
+            this.parseBtn.TabIndex = 1;
+            this.parseBtn.Text = "Parse Constraints";
+            this.parseBtn.UseVisualStyleBackColor = true;
+            this.parseBtn.Click += new System.EventHandler(this.parseBtn_Click);
+            // 
+            // label1
+            // 
+            this.infoLabel.AutoSize = true;
+            this.infoLabel.Dock = System.Windows.Forms.DockStyle.Top;
+            this.infoLabel.Image = global::HeuristicLab.Problems.DataAnalysis.Views.Properties.Resources.VS2008ImageLibrary_Annotations_Information;
+            this.infoLabel.Location = new System.Drawing.Point(3, 16);
+            this.infoLabel.Name = "label1";
+            this.infoLabel.Size = new System.Drawing.Size(19, 13);
+            this.infoLabel.TabIndex = 4;
+            this.infoLabel.Text = "    ";
+            this.toolTip.SetToolTip(this.infoLabel, "Double-click to open description.");
+            this.infoLabel.DoubleClick += new System.EventHandler(this.helpButton_DoubleClick);
+            // 
+            // errorOutput
+            // 
+            this.errorOutput.AutoSize = true;
+            this.errorOutput.Dock = System.Windows.Forms.DockStyle.Bottom;
+            this.errorOutput.ForeColor = System.Drawing.Color.DarkRed;
+            this.errorOutput.Location = new System.Drawing.Point(3, 613);
+            this.errorOutput.MaximumSize = new System.Drawing.Size(350, 0);
+            this.errorOutput.Name = "errorOutput";
+            this.errorOutput.Size = new System.Drawing.Size(35, 13);
+            this.errorOutput.TabIndex = 3;
+            this.errorOutput.Text = "label2";
+            // 
+            // intervalConstraintsView
+            // 
+            this.shapeConstraintsView.Dock = System.Windows.Forms.DockStyle.Fill;
+            this.shapeConstraintsView.Location = new System.Drawing.Point(0, 0);
+            this.shapeConstraintsView.Name = "intervalConstraintsView";
+            this.shapeConstraintsView.Size = new System.Drawing.Size(588, 629);
+            this.shapeConstraintsView.TabIndex = 2;
+            this.shapeConstraintsView.TabStop = false;
+            // 
+            // ShapeConstraintsView
+            // 
+            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+            this.Controls.Add(this.splitContainer);
+            this.Name = "ShapeConstraintsView";
+            this.Size = new System.Drawing.Size(888, 629);
+            this.splitContainer.Panel1.ResumeLayout(false);
+            this.splitContainer.Panel2.ResumeLayout(false);
+            ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
+            this.splitContainer.ResumeLayout(false);
+            this.groupBox.ResumeLayout(false);
+            this.groupBox.PerformLayout();
+            this.ResumeLayout(false);
+
+    }
+    #endregion
+
+    private System.Windows.Forms.SplitContainer splitContainer;
+    private System.Windows.Forms.GroupBox groupBox;
+    private System.Windows.Forms.Button parseBtn;
+    private HeuristicLab.Core.Views.CheckedItemListView<ShapeConstraint> shapeConstraintsView;
+    private System.Windows.Forms.TextBox constraintsInput;
+    private Label errorOutput;
+    private Label infoLabel;
+    protected ToolTip toolTip;
+    }
+}
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/ShapeConstraintsView.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/ShapeConstraintsView.cs	(revision 17902)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/ShapeConstraintsView.cs	(revision 17902)
@@ -0,0 +1,177 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System;
+using System.Drawing;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Collections;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.Problems.DataAnalysis.Views {
+  [View("ShapeConstraints View")]
+  [Content(typeof(ShapeConstraints), true)]
+  public partial class ShapeConstraintsView : AsynchronousContentView {
+    public new ShapeConstraints Content {
+      get => (ShapeConstraints)base.Content;
+      set => base.Content = value;
+    }
+
+    public bool suspendUpdates = false;
+
+    public ShapeConstraintsView() {
+      InitializeComponent();
+      errorOutput.Text = "";
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      this.shapeConstraintsView.Content = Content;
+      UpdateControl();
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.ItemsAdded += constraints_Added;
+      Content.ItemsRemoved += constraint_Removed;
+      Content.Changed += Content_Changed;
+      Content.CollectionReset += constraints_Reset;
+      Content.ItemsMoved += constraints_Moved;
+      Content.ItemsReplaced += Content_ItemsReplaced;
+      Content.CheckedItemsChanged += Content_CheckedItemsChanged;
+    }
+
+
+    protected override void DeregisterContentEvents() {
+      Content.ItemsAdded -= constraints_Added;
+      Content.ItemsRemoved -= constraint_Removed;
+      Content.Changed -= Content_Changed;
+      Content.CollectionReset -= constraints_Reset;
+      Content.ItemsMoved -= constraints_Moved;
+      Content.ItemsReplaced -= Content_ItemsReplaced;
+      Content.CheckedItemsChanged -= Content_CheckedItemsChanged;
+      base.DeregisterContentEvents();
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      constraintsInput.Enabled = Content != null && !Locked && !ReadOnly;
+    }
+
+
+    private void parseBtn_Click(object sender, EventArgs e) {
+      if (constraintsInput.Text != null) {
+        suspendUpdates = true;
+        Content.Clear();
+        try {
+          var parsedConstraints = ShapeConstraintsParser.ParseConstraints(constraintsInput.Text);
+          Content.AddRange(parsedConstraints);
+          errorOutput.Text = "Constraints successfully parsed.";
+          errorOutput.ForeColor = Color.DarkGreen;
+        } catch (ArgumentException ex) {
+          errorOutput.Text = ex.Message.Replace("Parameter name", "@Line");
+          errorOutput.ForeColor = Color.DarkRed;
+        } finally {
+          suspendUpdates = false;
+        }
+      } else {
+        errorOutput.Text = "No constraints were found!";
+      }
+    }
+
+    private void UpdateControl() {
+      if (suspendUpdates) return;
+      if (Content == null) {
+        constraintsInput.Text = string.Empty;
+      } else {
+        var newText = ToString(Content);
+        if (newText != constraintsInput.Text)
+          constraintsInput.Text = newText;
+      }
+    }
+
+    private string ToString(ShapeConstraints constraints) {
+      var sb = new StringBuilder();
+      foreach (var constraint in constraints) {
+        if (!constraints.ItemChecked(constraint)) {
+          sb.Append("# ").AppendLine(constraint.ToString());
+        } else {
+          sb.AppendLine(constraint.ToString());
+        }
+      }
+      return sb.ToString();
+    }
+
+    private void constraint_Changed(object sender, EventArgs e) {
+      UpdateControl();
+    }
+
+    private void constraints_Added(object sender,
+                                     CollectionItemsChangedEventArgs<IndexedItem<ShapeConstraint>> e) {
+      foreach (var addedItem in e.Items) addedItem.Value.Changed += constraint_Changed;
+      UpdateControl();
+    }
+
+    private void constraint_Removed(object sender, CollectionItemsChangedEventArgs<IndexedItem<ShapeConstraint>> e) {
+      foreach (var removedItem in e.Items) removedItem.Value.Changed -= constraint_Changed;
+      UpdateControl();
+    }
+
+    private void constraints_Moved(object sender, CollectionItemsChangedEventArgs<IndexedItem<ShapeConstraint>> e) {
+      UpdateControl();
+    }
+
+    private void constraints_Reset(object sender, CollectionItemsChangedEventArgs<IndexedItem<ShapeConstraint>> e) {
+      foreach (var addedItem in e.Items) addedItem.Value.Changed += constraint_Changed;
+      foreach (var removedItem in e.OldItems) removedItem.Value.Changed -= constraint_Changed;
+      UpdateControl();
+    }
+
+    private void Content_CheckedItemsChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<ShapeConstraint>> e) {
+      UpdateControl();
+    }
+
+    private void Content_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<ShapeConstraint>> e) {
+      foreach (var addedItem in e.Items) addedItem.Value.Changed += constraint_Changed;
+      foreach (var removedItem in e.OldItems) removedItem.Value.Changed -= constraint_Changed;
+      UpdateControl();
+    }
+
+    private void constraintsInput_TextChanged(object sender, EventArgs e) {
+      errorOutput.Text = "Unparsed changes! Press parse button to save changes.";
+      errorOutput.ForeColor = Color.DarkOrange;
+    }
+
+    private void Content_Changed(object sender, EventArgs e) {
+      UpdateControl();
+    }
+
+    private void helpButton_DoubleClick(object sender, EventArgs e) {
+      using (InfoBox dialog = new InfoBox("Help for shape constraints",
+        "HeuristicLab.Problems.DataAnalysis.Views.Resources.shapeConstraintsHelp.rtf",
+        this)) {
+        dialog.ShowDialog(this);
+      }
+    }
+  }
+}
Index: /trunk/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj	(revision 17901)
+++ /trunk/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj	(revision 17902)
@@ -142,7 +142,10 @@
     <Compile Include="Implementation\Interval\Interval.cs" />
     <Compile Include="Implementation\Interval\IntervalCollection.cs" />
+    <Compile Include="Implementation\Interval\ShapeConstraint.cs" />
+    <Compile Include="Implementation\Interval\ShapeConstraintsParser.cs" />
     <Compile Include="Implementation\Regression\ConfidenceBoundRegressionSolution.cs" />
     <Compile Include="Implementation\Regression\ConstantRegressionModel.cs" />
     <Compile Include="Implementation\Regression\ConstantRegressionSolution.cs" />
+    <Compile Include="Implementation\Regression\ShapeConstraints.cs" />
     <Compile Include="Implementation\Regression\RegressionEnsembleProblemData.cs" />
     <Compile Include="Implementation\Regression\RegressionEnsembleModel.cs">
Index: /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/Interval.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/Interval.cs	(revision 17901)
+++ /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/Interval.cs	(revision 17902)
@@ -33,4 +33,6 @@
     [Storable]
     public double UpperBound { get; private set; }
+
+    public double Width => UpperBound - LowerBound;
 
     [StorableConstructor]
@@ -67,4 +69,6 @@
     }
 
+    private Interval(double v) : this(v, v) { }
+
     public bool Contains(double value) {
       return LowerBound <= value && value <= UpperBound;
@@ -126,6 +130,6 @@
         return false;
 
-      return (UpperBound.IsAlmost(other.UpperBound) || (double.IsNaN(UpperBound) && double.IsNaN(other.UpperBound)))
-        && (LowerBound.IsAlmost(other.LowerBound) || (double.IsNaN(LowerBound) && double.IsNaN(other.LowerBound)));
+      return (UpperBound==other.UpperBound || (double.IsNaN(UpperBound) && double.IsNaN(other.UpperBound)))
+        && (LowerBound==other.LowerBound || (double.IsNaN(LowerBound) && double.IsNaN(other.LowerBound)));
     }
 
@@ -276,4 +280,34 @@
     }
     #endregion
+
+    #region arithmetic overloads
+    public static Interval operator +(Interval a, Interval b) => Add(a, b);
+    public static Interval operator +(Interval a, double b) => Add(a, new Interval(b));
+    public static Interval operator +(double a, Interval b) => Add(new Interval(a), b);
+    public static Interval operator -(Interval a, Interval b) => Subtract(a, b);
+    public static Interval operator -(Interval a, double b) => Subtract(a, new Interval(b));
+    public static Interval operator -(double a, Interval b) => Subtract(new Interval(a), b);
+    public static Interval operator -(Interval a) => Subtract(new Interval(0), a);
+    public static Interval operator *(Interval a, Interval b) => Multiply(a, b);
+    public static Interval operator *(Interval a, double b) => Multiply(a, new Interval(b));
+    public static Interval operator *(double a, Interval b) => Multiply(new Interval(a), b);
+    public static Interval operator /(Interval a, Interval b) => Divide(a, b);
+    public static Interval operator /(Interval a, double b) => Divide(a, new Interval(b));
+    public static Interval operator /(double a, Interval b) => Divide(new Interval(a), b);
+    public static Interval Exponential(double a) { return Exponential(new Interval(a)); }
+    public static Interval Logarithm(double a) { return Logarithm(new Interval(a)); }
+    public static Interval Sine(double a) { return Sine(new Interval(a)); }
+    public static Interval Cosine(double a) { return Cosine(new Interval(a)); }
+    public static Interval Tangens(double a) { return Tangens(new Interval(a)); }
+    public static Interval HyperbolicTangent(double a) { return HyperbolicTangent(new Interval(a)); }
+    public static Interval Square(double a) { return Square(new Interval(a)); }
+    public static Interval Cube(double a) { return Cube(new Interval(a)); }
+    public static Interval SquareRoot(double a) { return SquareRoot(new Interval(a)); }
+    public static Interval CubicRoot(double a) { return CubicRoot(new Interval(a)); }
+    public static Interval Absolute(double a) { return Absolute(new Interval(a)); }
+    public static Interval AnalyticQuotient(Interval a, double b) { return AnalyticalQuotient(a, new Interval(b)); }
+    public static Interval AnalyticQuotient(double a, Interval b) { return AnalyticalQuotient(new Interval(a), b); }
+    public static Interval AnalyticQuotient(double a, double b) { return AnalyticalQuotient(new Interval(a), new Interval(b)); }
+    #endregion
   }
 }
Index: /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalCollection.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalCollection.cs	(revision 17901)
+++ /trunk/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval/IntervalCollection.cs	(revision 17902)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -34,20 +34,34 @@
       get => HeuristicLab.Common.Resources.VSImageLibrary.Object;
     }
-    private IDictionary<string, Interval> intervals { get; } = new Dictionary<string, Interval>();
 
-    [Storable(Name = "StorableIntervalInformation")]
+    //[Storable]
+    private IDictionary<string, Interval> intervals { get; set; } = new Dictionary<string, Interval>();
+
+    [Storable(OldName = "StorableIntervalInformation")]
     private KeyValuePair<string, double[]>[] StorableIntervalInformation {
+      set {
+        foreach (var varInt in value)
+          intervals.Add(varInt.Key, new Interval(varInt.Value[0], varInt.Value[1]));
+      }
+    }
+
+    [Storable]
+    private object[] StorableIntervals {
       get {
-        var l = new List<KeyValuePair<string, double[]>>();
-        foreach (var varInt in intervals)
+        var names = intervals.Keys.ToArray();
+        var lowerBounds = intervals.Values.Select(i => i.LowerBound).ToArray();
+        var upperBounds = intervals.Values.Select(i => i.UpperBound).ToArray();
 
-          l.Add(new KeyValuePair<string, double[]>(varInt.Key,
-            new double[] { varInt.Value.LowerBound, varInt.Value.UpperBound }));
-        return l.ToArray();
+        return new object[] { names, lowerBounds, upperBounds };
       }
 
       set {
-        foreach (var varInt in value)
-          intervals.Add(varInt.Key, new Interval(varInt.Value[0], varInt.Value[1]));
+        var names = (string[])value[0];
+        var lowerBounds = (double[])value[1];
+        var upperBounds = (double[])value[2];
+
+        for (int i = 0; i < names.Length; i++) {
+          intervals.Add(names[i], new Interval(lowerBounds[i], upperBounds[i]));
+        }
       }
     }
@@ -80,15 +94,22 @@
     public void SetInterval(string identifier, Interval interval) {
       intervals[identifier] = interval;
+      RaiseChanged();
     }
 
     public void AddInterval(string identifier, Interval interval) {
       intervals.Add(identifier, interval);
+      RaiseChanged();
     }
 
     public void DeleteInterval(string identifier) {
       intervals.Remove(identifier);
+      RaiseChanged();
     }
 
     public IReadOnlyDictionary<string, Interval> GetReadonlyDictionary() {
+      return intervals.ToDictionary(pair => pair.Key, pair => pair.Value);
+    }
+
+    public IDictionary<string, Interval> GetDictionary() {
       return intervals.ToDictionary(pair => pair.Key, pair => pair.Value);
     }
@@ -98,4 +119,12 @@
         yield return Tuple.Create(variableInterval.Key, variableInterval.Value);
     }
+
+    public event EventHandler Changed;
+    private void RaiseChanged() {
+      var handler = Changed;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+
   }
 }
